package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 用户表
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="AdminUser对象", description="用户表")
public class AdminUser extends Model<AdminUser> {

    private static final long serialVersionUID=1L;

    @TableId(value = "admin_user_id", type = IdType.ID_WORKER_STR)
    private String adminUserId;

    @ApiModelProperty(value = "网点id")
    private String websitId;

    @ApiModelProperty(value = "网点名称")
    private String websitNumber;

    @ApiModelProperty(value = "用户名")
    private String nickName;

    @ApiModelProperty(value = "ON=开启 OFF=关闭")
    private String status;

    @ApiModelProperty(value = "最后登录时间")
    private Date lastLoginTime;

    @ApiModelProperty(value = "帐号")
    private String userName;

    @ApiModelProperty(value = "密码")
    private String password;

    @ApiModelProperty(value = "联系人")
    private String linkName;

    @ApiModelProperty(value = "联系人电话")
    private String linkPhone;

    @ApiModelProperty(value = "邮箱")
    private String email;

    @ApiModelProperty(value = "地址")
    private String address;

    @ApiModelProperty(value = "是否为主账号 YES/NO")
    private String master;

    @ApiModelProperty(value = "true:已删除，false:未删除")
    @TableLogic
    private Boolean del;

    @ApiModelProperty(value = "（X=销售 S=售后  A=平台 M=信息员）(作废，请关注角色类型）")
    private String type;

    @ApiModelProperty(value = "手机帐号")
    private String loginMobile;

    @ApiModelProperty(value = "明文密码")
    private String decodePwd;

    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "是否首次登录 true=是 false=否")
    private Boolean notFirstLogin;

    @ApiModelProperty(value = "安装信息员等级id")
    private String installLevelId;

    @ApiModelProperty(value = "安装信息员等级id")
    private String installLevelName;

    @ApiModelProperty(value = "安装等级")
    private String installType;

    @ApiModelProperty(value = "维修信息员等级id")
    private String repairLevelId;

    @ApiModelProperty(value = "维修等级")
    private String repairType;

    @ApiModelProperty(value = "维修信息员等级id")
    private String repairLevelName;

    @ApiModelProperty(value = "每日处理工单最大量")
    private Integer installNum;

    @ApiModelProperty(value = "未完成工单")
    private Integer noInstallNum;

    @ApiModelProperty(value = "每日处理工单最大量")
    private Integer repairNum;

    @ApiModelProperty(value = "未完成工单")
    private Integer noRepairNum;

    @ApiModelProperty(value = "班组id")
    private String teamId;

    @ApiModelProperty(value = "班组名称")
    private String teamName;

    @ApiModelProperty(value = "供应链系统帐号")
    private String supplyUserName;

    @ApiModelProperty(value = "供应链系统密码")
    private String supplyPassword;

    @ApiModelProperty(value = "是否绑定供应链帐号 YES=是 NO=否")
    private String bindSupply;

    @ApiModelProperty(value = "联通云呼integratedid")
    private String unicomIntegratedId;

    @ApiModelProperty(value = "联通云呼ExtenType（支持三种方式Local（直线方式），sip（软电话），gateway（语音网关/IP话机））")
    private String unicomIntegratedType;

    @ApiModelProperty(value = "最后接单时间")
    private Date lastOrderTime;

    @ApiModelProperty(value = "是否外部接口帐号")
    private Boolean isOutside;

    @ApiModelProperty(value = "签名图片")
    private String signatureImg;


    @Override
    protected Serializable pkVal() {
        return this.adminUserId;
    }

}
