package com.zfire.jiasm.syncdata.plus.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 各个品牌的网点信息
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="BrandWebsit对象", description="各个品牌的网点信息")
public class BrandWebsit extends Model<BrandWebsit> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "主键")
    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "品牌方网点的主键id")
    private String brandPkId;

    @ApiModelProperty(value = "公司id")
    private Integer belongCompanyId;

    @ApiModelProperty(value = "所属销售公司")
    private String belongCompany;

    @ApiModelProperty(value = "网点类型 S=售后网点  X=销售网点")
    private String type;

    @ApiModelProperty(value = "格力系统网点编号")
    private String sysWebsitNumber;

    @ApiModelProperty(value = "格力品牌的网点编号")
    private String brandWebsitNumber;

    @ApiModelProperty(value = "格力品牌的网点名称")
    private String brandWebsitName;

    @ApiModelProperty(value = "网点负责人")
    private String fzren;

    @ApiModelProperty(value = "负责人手机")
    private String yddh;

    @ApiModelProperty(value = "办公电话号码")
    private String dhhm;

    @ApiModelProperty(value = "是否独立法人机构(是、否)")
    private String sfdlfr;

    @ApiModelProperty(value = "企业法人代表")
    private String lxren;

    @ApiModelProperty(value = "法人身份证号码")
    private String fzrsfz;

    @ApiModelProperty(value = "税号")
    private String shao;

    @ApiModelProperty(value = "开户银行")
    private String khyh;

    @ApiModelProperty(value = "银行：行号")
    private String hanghao;

    @ApiModelProperty(value = "银行帐号")
    private String yhzh;

    @ApiModelProperty(value = "品类ID")
    private String splb;

    @ApiModelProperty(value = "品类名称")
    private String splbmc;

    @ApiModelProperty(value = "服务类目")
    private String fwlm;

    @ApiModelProperty(value = "网点级别（一、二、三级）")
    private String wdjb;

    @ApiModelProperty(value = "是否承揽电商工单(是、否)")
    private String sfdsqy;

    @ApiModelProperty(value = "服务热线")
    private String fwrx;

    @ApiModelProperty(value = "网点状态(ONE未启用、TOW正常、THREE无效)")
    private String stat;

    @ApiModelProperty(value = "售后人员总数")
    private Integer shnum;

    @ApiModelProperty(value = "固定配送工人数")
    private Integer psry;

    @ApiModelProperty(value = "固定安装工人数")
    private Integer azry;

    @ApiModelProperty(value = "固定维修工人数")
    private Integer wxry;

    @ApiModelProperty(value = "售后服务汽车（辆）")
    private Integer shqcnum;

    @ApiModelProperty(value = "日维修数量")
    private Integer rwxnum;

    @ApiModelProperty(value = "每日安装最高承载量")
    private Integer mrzgczl;

    @ApiModelProperty(value = "仓库面积")
    private String ckmj;

    @ApiModelProperty(value = "省份")
    private String sfen;

    @ApiModelProperty(value = "城市")
    private String cshi;

    @ApiModelProperty(value = "县/区")
    private String xian;

    @ApiModelProperty(value = "乡镇(街道)")
    private String xzhen;

    @ApiModelProperty(value = "详细地址")
    private String dizi;

    @ApiModelProperty(value = "经度")
    private BigDecimal jingdu;

    @ApiModelProperty(value = "纬度")
    private BigDecimal weidu;

    @ApiModelProperty(value = "区号")
    private String quhao;

    @ApiModelProperty(value = "备注")
    private String beiz;

    @ApiModelProperty(value = "集团公司id")
    private String groupCompanyId;

    @ApiModelProperty(value = "集团公司名称")
    private String groupCompanyName;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "修改时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "修改人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
