package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="CompanyCaAuth对象", description="")
public class CompanyCaAuth extends Model<CompanyCaAuth> {

    private static final long serialVersionUID=1L;

    @TableId(value = "company_ca_auth_id", type = IdType.ID_WORKER_STR)
    private String companyCaAuthId;

    @ApiModelProperty(value = "所属服务商id")
    private String websitId;

    @ApiModelProperty(value = "网点名称")
    private String websitName;

    @ApiModelProperty(value = "公司名称")
    private String companyName;

    @ApiModelProperty(value = "公司地址")
    private String companyAddress;

    @ApiModelProperty(value = "统一社会信用代码")
    private String taxNo;

    @ApiModelProperty(value = "组织机构代码")
    private String orgNumber;

    @ApiModelProperty(value = "营业执照附件")
    private String businessLicenseUrl;

    @ApiModelProperty(value = "法人")
    private String legalName;

    @ApiModelProperty(value = "法人联系方式")
    private String legalPhone;

    @ApiModelProperty(value = "法人身份证")
    private String legalId;

    @ApiModelProperty(value = "法大大客户编号")
    private String fadadaCustomerId;

    @ApiModelProperty(value = "法大大认证交易号")
    private String fadadaTransactionNo;

    @ApiModelProperty(value = "法大大认证地址")
    private String fadadaAuthUrl;

    @ApiModelProperty(value = "法大大是否已认证 YES=是 NO=否")
    private String fadadaIsAuth;

    @ApiModelProperty(value = "法大大授权状态(0：未认证;1：管理员资料已提交;2：企业基本资料(没有申请表)已提交;3：已提交待审核;4：审核通过（认证完成）;5：审核不通过;6：人工初审通过)")
    private String fadadaStatus;

    @ApiModelProperty(value = "法大大不通过原因")
    private String fadadaAuditFailReason;

    @ApiModelProperty(value = "法大大自动签授权交易号")
    private String fadadaAuthAutoId;

    @ApiModelProperty(value = "法大大自动签授权合同编号")
    private String fadadaAuthAutoContractId;

    @ApiModelProperty(value = "法大大自动签授权状态  YES=是 NO=否")
    private String fadadaAuthAutoStatus;

    @ApiModelProperty(value = "法大大自动签授权地址")
    private String fadadaAuthAutoUrl;

    @ApiModelProperty(value = "法大大自动签授权查看地址")
    private String fadadaAuthAutoViewpdfUrl;

    @ApiModelProperty(value = "法大大自动签授权下载地址")
    private String fadadaAuthAutoDownloadUrl;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "true:已删除，false:未删除")
    @TableLogic
    private Boolean del;


    @Override
    protected Serializable pkVal() {
        return this.companyCaAuthId;
    }

}
