package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 保险邮箱配置
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="InsureEmail对象", description="保险邮箱配置")
public class InsureEmail extends Model<InsureEmail> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "发件人邮箱")
    private String sendEmail;

    @ApiModelProperty(value = "发件人昵称")
    private String sendName;

    @ApiModelProperty(value = "发件人密码")
    private String sendPassword;

    @ApiModelProperty(value = "企业id")
    private String corpId;

    @ApiModelProperty(value = "应用的凭证密钥")
    private String secret;

    @ApiModelProperty(value = "接收邮箱-通用（多个逗号隔开）")
    private String receComEmail;

    @ApiModelProperty(value = "接收邮箱-意外险专用(多个逗号隔开)")
    private String receYwxEmail;

    @ApiModelProperty(value = "每日发送时间(HH:mm:ss)")
    private String sendDailyTime;

    @ApiModelProperty(value = "到期前多少天提醒")
    private Integer noticeDay;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "修改时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "修改人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
