package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 工程师等级说明配置
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="IntegralGradeExplain对象", description="工程师等级说明配置")
public class IntegralGradeExplain extends Model<IntegralGradeExplain> {

    private static final long serialVersionUID=1L;

    @TableId(value = "grade_explain_id", type = IdType.ID_WORKER_STR)
    private String gradeExplainId;

    @ApiModelProperty(value = "标题")
    private String explainName;

    @ApiModelProperty(value = "状态 YES 开启 NO 关闭")
    private String status;

    @ApiModelProperty(value = "内容")
    private String notes;

    @ApiModelProperty(value = "创建人（制单人）")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;


    @Override
    protected Serializable pkVal() {
        return this.gradeExplainId;
    }

}
