package com.zfire.jiasm.syncdata.plus.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 分值配置
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="IntegralScore对象", description="分值配置")
public class IntegralScore extends Model<IntegralScore> {

    private static final long serialVersionUID=1L;

    @TableId(value = "score_id", type = IdType.ID_WORKER_STR)
    private String scoreId;

    @ApiModelProperty(value = "初始分值设置")
    private BigDecimal initialNum;

    @ApiModelProperty(value = "等级id")
    private String gradeConfigureId;

    @ApiModelProperty(value = "初始用户端等级")
    private String gradeUserConfigureName;

    @ApiModelProperty(value = "初始等级名称")
    private String gradeConfigureName;

    @ApiModelProperty(value = "初始服务分")
    private BigDecimal serviceNum;

    @ApiModelProperty(value = "初始质量分值")
    private BigDecimal qualityNum;

    @ApiModelProperty(value = "初始技能分值")
    private BigDecimal skillNum;

    @ApiModelProperty(value = "完成工单分值")
    private BigDecimal orderNum;

    @ApiModelProperty(value = "反馈时间内")
    private BigDecimal backNum;

    @ApiModelProperty(value = "反馈时间内获得的分值")
    private BigDecimal backBranch;

    @ApiModelProperty(value = "反馈时间外")
    private BigDecimal backNoNum;

    @ApiModelProperty(value = "反馈时间外获得的分值")
    private BigDecimal backNoBranch;

    @ApiModelProperty(value = "接收时间内")
    private BigDecimal receiveNum;

    @ApiModelProperty(value = "接收时间内获得分值")
    private BigDecimal receiveBranch;

    @ApiModelProperty(value = "接收时间外")
    private BigDecimal receiveNoNum;

    @ApiModelProperty(value = "接收时间外获得分值")
    private BigDecimal receiveNoBranch;

    @ApiModelProperty(value = "准时签到分值")
    private BigDecimal makeBranch;

    @ApiModelProperty(value = "超时签到分值")
    private BigDecimal makeNoBranch;

    @ApiModelProperty(value = "开始时间")
    private Date startTime;

    @ApiModelProperty(value = "每月加分")
    private BigDecimal startNum;

    @ApiModelProperty(value = "拥有大类或技能")
    private BigDecimal haveSkillNum;

    @ApiModelProperty(value = "拥有证件")
    private BigDecimal haveCardNum;

    @ApiModelProperty(value = "拥有工具")
    private BigDecimal haveToolNum;

    @ApiModelProperty(value = "拥有资质")
    private BigDecimal haveQualificationNum;

    @ApiModelProperty(value = "满意")
    private BigDecimal satisfiedNum;

    @ApiModelProperty(value = "不满意")
    private BigDecimal dissatisfiedNum;

    @ApiModelProperty(value = "一般")
    private BigDecimal commonlyNum;

    @ApiModelProperty(value = "创建人（制单人）")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;


    @Override
    protected Serializable pkVal() {
        return this.scoreId;
    }

}
