package com.zfire.jiasm.syncdata.plus.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 市信息下载记录
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="ItfTblCityDownload对象", description="市信息下载记录")
public class ItfTblCityDownload extends Model<ItfTblCityDownload> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "同步任务id")
    private String synTaskNo;

    @ApiModelProperty(value = "同步任务号")
    @TableId(value = "syn_req_id", type = IdType.AUTO)
    private Long synReqId;

    @ApiModelProperty(value = "同步任务生成时间")
    private Date synReqTime;

    @ApiModelProperty(value = "同步标志 0=未同步 1=已同步")
    private Integer synStatus;

    @ApiModelProperty(value = "同步时间")
    private Date synTime;

    @ApiModelProperty(value = "同步错误次数")
    private Integer synTimes;

    @ApiModelProperty(value = "同步错误信息")
    private String synErrMsg;

    private Long ciid;

    private String createdBy;

    private Date createdDate;

    private String lastModifiedBy;

    private Date lastModifiedDate;

    @ApiModelProperty(value = "省份")
    private String sfen;

    @ApiModelProperty(value = "地市")
    private String city;

    @ApiModelProperty(value = "状态(1历史 2正常)")
    private BigDecimal stat;

    @ApiModelProperty(value = "操作人")
    private String czren;

    @ApiModelProperty(value = "操作时间")
    private Date czsj;

    @ApiModelProperty(value = "引用省ID")
    private String shenid;


    @Override
    protected Serializable pkVal() {
        return this.synReqId;
    }

}
