package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 乡镇信息下载记录
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="ItfTblCityJdxzDownload对象", description="乡镇信息下载记录")
public class ItfTblCityJdxzDownload extends Model<ItfTblCityJdxzDownload> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "同步任务id")
    private String synTaskNo;

    @ApiModelProperty(value = "同步任务号")
    @TableId(value = "syn_req_id", type = IdType.AUTO)
    private Long synReqId;

    @ApiModelProperty(value = "同步任务生成时间")
    private Date synReqTime;

    @ApiModelProperty(value = "同步标志 0=未同步 1=已同步")
    private Integer synStatus;

    @ApiModelProperty(value = "同步时间")
    private Date synTime;

    @ApiModelProperty(value = "同步错误次数")
    private Integer synTimes;

    @ApiModelProperty(value = "同步错误信息")
    private String synErrMsg;

    private String xzdm;

    private String createdBy;

    private Date createdDate;

    private String lastModifiedBy;

    private Date lastModifiedDate;

    @ApiModelProperty(value = "街道乡镇名称")
    private String xzmc;

    @ApiModelProperty(value = "省份")
    private String sfen;

    @ApiModelProperty(value = "市")
    private String city;

    @ApiModelProperty(value = "区县")
    private String county;

    @ApiModelProperty(value = "区号")
    private String quhao;

    @ApiModelProperty(value = "邮政编码")
    private String yzbm;

    @ApiModelProperty(value = "区县行政代码")
    private String qydm;

    @ApiModelProperty(value = "旧区县行政代码")
    private String jqydm;

    @ApiModelProperty(value = "创建日期")
    private Date cjdt;

    @ApiModelProperty(value = "状态是否有效。1表示有效，0表示无效")
    private Integer stat;


    @Override
    protected Serializable pkVal() {
        return this.synReqId;
    }

}
