package com.zfire.jiasm.syncdata.plus.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 网点基础下载记录
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="ItfTblXinWangdianDownload对象", description="网点基础下载记录")
public class ItfTblXinWangdianDownload extends Model<ItfTblXinWangdianDownload> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "同步任务id")
    private String synTaskNo;

    @ApiModelProperty(value = "同步任务号")
    @TableId(value = "syn_req_id", type = IdType.AUTO)
    private Long synReqId;

    @ApiModelProperty(value = "同步任务生成时间")
    private Date synReqTime;

    @ApiModelProperty(value = "同步标志 0=未同步 1=已同步")
    private Integer synStatus;

    @ApiModelProperty(value = "同步时间")
    private Date synTime;

    @ApiModelProperty(value = "同步错误次数")
    private Integer synTimes;

    @ApiModelProperty(value = "同步错误信息")
    private String synErrMsg;

    private String pkGuid;

    private String createdBy;

    private Date createdDate;

    private String lastModifiedBy;

    private Date lastModifiedDate;

    @ApiModelProperty(value = "系统网点编号")
    private String xtwdbh;

    @ApiModelProperty(value = "新网点编号")
    private String wdno;

    @ApiModelProperty(value = "网点名称")
    private String wdmc;

    @ApiModelProperty(value = "负责人")
    private String fzren;

    @ApiModelProperty(value = "企业法人代表")
    private String lxren;

    @ApiModelProperty(value = "区号")
    private String quhao;

    @ApiModelProperty(value = "电话号码")
    private String dhhm;

    @ApiModelProperty(value = "负责人手机")
    private String yddh;

    @ApiModelProperty(value = "传真")
    private String czhen;

    @ApiModelProperty(value = "邮编")
    private String ybian;

    @ApiModelProperty(value = "省份")
    private String sfen;

    @ApiModelProperty(value = "市")
    private String cshi;

    @ApiModelProperty(value = "县")
    private String xian;

    @ApiModelProperty(value = "乡镇")
    private String xzhen;

    @ApiModelProperty(value = "地址")
    private String dizi;

    @ApiModelProperty(value = "有无协议")
    private String ywxy;

    @ApiModelProperty(value = "协议编号")
    private String xybh;

    @ApiModelProperty(value = "签约开始时间")
    private Date xykssj;

    @ApiModelProperty(value = "签约终止时间")
    private Date xyzzsj;

    @ApiModelProperty(value = "续约时间")
    private Date xyxysj;

    @ApiModelProperty(value = "开户银行")
    private String khyh;

    @ApiModelProperty(value = "银行帐号")
    private String yhzh;

    @ApiModelProperty(value = "许可证,营业执照号")
    private String xkzh;

    @ApiModelProperty(value = "email")
    private String mail;

    @ApiModelProperty(value = "网点类别(总部、分部、办事处，类别对应表)")
    private String wdlb;

    @ApiModelProperty(value = "网点级别（1、2、3级）")
    private String wdjb;

    @ApiModelProperty(value = "经营性质（专卖店、专营店、综合店）")
    private String wdxz;

    @ApiModelProperty(value = "备注")
    private String beiz;

    @ApiModelProperty(value = "网点状态(1未启用、2正常、3锁定)")
    private Integer stat;

    @ApiModelProperty(value = "操作人")
    private String czren;

    @ApiModelProperty(value = "创建时间")
    private Date cjsj;

    @ApiModelProperty(value = "操作信息")
    private String czxx;

    @ApiModelProperty(value = "审批人(启用网点)－－后续销售公司自己添加网点使用")
    private String spren;

    @ApiModelProperty(value = "审批备注")
    private String spbeib;

    @ApiModelProperty(value = "启用网点时间")
    private String spsj;

    @ApiModelProperty(value = "经营层级")
    private String jycj;

    @ApiModelProperty(value = "专卖店编号(专卖店必填）")
    private String zmdbh;

    @ApiModelProperty(value = "法人身份证号码")
    private String fzrsfz;

    @ApiModelProperty(value = "商品类别")
    private String sysfxs;

    @ApiModelProperty(value = "已销售商用机组")
    private String syxsjz;

    @ApiModelProperty(value = "商用业务联系人")
    private String syywy;

    @ApiModelProperty(value = "商用业务联系人职位")
    private String syywyzw;

    @ApiModelProperty(value = "商用业务联系人电话")
    private String syywydh;

    @ApiModelProperty(value = "商用是否有门面")
    private String sysfymm;

    @ApiModelProperty(value = "商用业务人员")
    private String syyw;

    @ApiModelProperty(value = "商用设计人员")
    private String sysj;

    @ApiModelProperty(value = "商用施工人员")
    private String sysg;

    @ApiModelProperty(value = "经营面积")
    private String jymj;

    @ApiModelProperty(value = "仓库面积")
    private String ckmj;

    @ApiModelProperty(value = "办公面积")
    private String bgmj;

    @ApiModelProperty(value = "专卖店层级分类；三级")
    private String zmdcjfl;

    @ApiModelProperty(value = "专卖店规模")
    private String zmdgm;

    @ApiModelProperty(value = "新建专卖店日期")
    private String xjwdrq;

    @ApiModelProperty(value = "销售人员")
    private Integer xsry;

    @ApiModelProperty(value = "固定配送工人数")
    private Integer psry;

    @ApiModelProperty(value = "固定安装工人数")
    private Integer azry;

    @ApiModelProperty(value = "固定维修工人数")
    private Integer wxry;

    @ApiModelProperty(value = "结算人员")
    private Integer jsry;

    @ApiModelProperty(value = "是否重点商圈")
    private String sfzdsq;

    @ApiModelProperty(value = "所属重点商圈")
    private String sszdsq;

    @ApiModelProperty(value = "销售目标")
    private String xsmb;

    @ApiModelProperty(value = "完成额度")
    private String wced;

    @ApiModelProperty(value = "销售或售后")
    private String xsorsh;

    @ApiModelProperty(value = "最后操作时间")
    private Date zhczsj;

    @ApiModelProperty(value = "旧网点编号")
    private String jwdno;

    @ApiModelProperty(value = "经度－IBM电商需要")
    private BigDecimal jingdu;

    @ApiModelProperty(value = "纬度－IBM电商需要")
    private BigDecimal weidu;

    @ApiModelProperty(value = "行政区域－IBM需要")
    private String xzqh;

    @ApiModelProperty(value = "服务质量评价－IBM电商需要")
    private Integer fwzlpj;

    @ApiModelProperty(value = "服务热线")
    private String fwrx;

    @ApiModelProperty(value = "新签or续签")
    private String xqorxq;

    @ApiModelProperty(value = "是否独立法人机构")
    private String sfdlfr;

    @ApiModelProperty(value = "行政区域代码")
    private String xzqyno;

    @ApiModelProperty(value = "税号")
    private String shao;

    @ApiModelProperty(value = "售后人员总数")
    private Integer shnum;

    @ApiModelProperty(value = "售后服务汽车（辆）")
    private Integer shqcnum;

    @ApiModelProperty(value = "天猫日安装数量")
    private Integer raznum;

    @ApiModelProperty(value = "日维修数量")
    private Integer rwxnum;

    @ApiModelProperty(value = "专卖店等级")
    private String zmddj;

    @ApiModelProperty(value = "经营性质（专卖店、专营店、超级连锁）")
    private String jyxz;

    @ApiModelProperty(value = "展示品牌")
    private String zspp;

    @ApiModelProperty(value = "展示品类")
    private String zspl;

    @ApiModelProperty(value = "陈长安测试使用")
    private String hqjwddz;

    @ApiModelProperty(value = "业务等级IBM电商需要(默认：优)")
    private String ywdj;

    @ApiModelProperty(value = "销售售后是否一家，guid编码")
    private String sfyjbs;

    @ApiModelProperty(value = "服务类别：安装, 维修, 配送")
    private String fwlb;

    @ApiModelProperty(value = "电商审核状态：通过，未通过")
    private String dssh;

    @ApiModelProperty(value = "派工负责人电话：售后")
    private String pgfzrtel;

    @ApiModelProperty(value = "派工负责人：售后")
    private String pgfzr;

    @ApiModelProperty(value = "是否电商签约网点：销售")
    private String sfdsqy;

    @ApiModelProperty(value = "是否需要抓取，是：电商定时过来抓")
    private String sfxyzq;

    @ApiModelProperty(value = "所属销售公司代码")
    private String ssxsgs;

    @ApiModelProperty(value = "电商专员电话（销售）；（售后：信息员）")
    private String dszydh;

    @ApiModelProperty(value = "电商专员 （销售）；（售后：信息员）")
    private String dszynm;

    @ApiModelProperty(value = "SFXYZQBAK")
    private String sfxyzqbak;

    @ApiModelProperty(value = "寻源级别")
    private String xyjb;

    @ApiModelProperty(value = "是否发送短信")
    private String sfme;

    @ApiModelProperty(value = "基础审批字段")
    private Integer seno;

    @ApiModelProperty(value = "是否 :结算录入")
    private String sfjslr;

    @ApiModelProperty(value = "银行：行号")
    private String hanghao;

    @ApiModelProperty(value = "五星网点分数")
    private Integer wxfensu;

    @ApiModelProperty(value = "每日安装最高承载量")
    private Integer mrzgczl;

    @ApiModelProperty(value = "是否需要抓取：默认“是”")
    private String tmallstat;

    @ApiModelProperty(value = "结算分区代码_肖本伟增加，不要删除")
    private String jsfq;

    @ApiModelProperty(value = "类别")
    private String splb;

    @ApiModelProperty(value = "乡镇ID")
    private String xzid;

    @ApiModelProperty(value = "区县ID")
    private Long qxid;

    @ApiModelProperty(value = "城市ID")
    private Long cshiid;

    @ApiModelProperty(value = "省份ID")
    private Long shenid;

    @ApiModelProperty(value = "业务员区域ID")
    private String areaid;

    @ApiModelProperty(value = "业务员ID")
    private String managerid;

    @ApiModelProperty(value = "服务VIP标识（1-5星，5最高）")
    private String vipflag;

    @ApiModelProperty(value = "商用服务范围")
    private String syfwfw;

    @ApiModelProperty(value = "家用服务范围")
    private String jyfwfw;

    @ApiModelProperty(value = "APP端配件库存查询权限 1  有权限可以查询  0 没有权限不能查询")
    private Integer kccxkz;


    @Override
    protected Serializable pkVal() {
        return this.synReqId;
    }

}
