package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 通知消息表
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="Notice对象", description="通知消息表")
public class Notice extends Model<Notice> {

    private static final long serialVersionUID=1L;

    @TableId(value = "notice_id", type = IdType.ID_WORKER_STR)
    private String noticeId;

    @ApiModelProperty(value = "文件标题")
    private String title;

    @ApiModelProperty(value = "文件编号")
    private String code;

    @ApiModelProperty(value = "消息内容")
    private String content;

    @ApiModelProperty(value = "公告类型 MANAGER 管理通知 TECHNOLOGY  技术通知 POLICY  政策通知TECHNOLOGY_INFO 技术资讯")
    private String type;

    @ApiModelProperty(value = "来源")
    private String source;

    @ApiModelProperty(value = "发布日期")
    private Date issueTime;

    @ApiModelProperty(value = "发布人id")
    private String issueUserId;

    @ApiModelProperty(value = "发布人名称")
    private String issueNickName;

    @ApiModelProperty(value = "公司id")
    private String adminCompanyId;

    @ApiModelProperty(value = "企业名称")
    private String adminCompanyName;

    @ApiModelProperty(value = "创建人（制单人）")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "已确认")
    private Integer num;

    @ApiModelProperty(value = "状态 YES 已发布 NO 未发布")
    private String status;


    @Override
    protected Serializable pkVal() {
        return this.noticeId;
    }

}
