package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 操作日志
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="OperationLog对象", description="操作日志")
public class OperationLog extends Model<OperationLog> {

    private static final long serialVersionUID=1L;

    @TableId(value = "operation_log_id", type = IdType.ID_WORKER_STR)
    private String operationLogId;

    @ApiModelProperty(value = "操作内容")
    private String content;

    @ApiModelProperty(value = "模块id")
    private String moduleId;

    @ApiModelProperty(value = "模块名称")
    private String moduleName;

    @ApiModelProperty(value = "用户id")
    private String adminUserId;

    @ApiModelProperty(value = "帐号")
    private String userName;

    @ApiModelProperty(value = "用户昵称")
    private String nickName;

    @ApiModelProperty(value = "ip地址")
    private String ip;

    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "企业id")
    private String adminCompanyId;

    @ApiModelProperty(value = "企业名称")
    private String adminCompanyName;


    @Override
    protected Serializable pkVal() {
        return this.operationLogId;
    }

}
