package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 资质材料管理表
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="QualificationsManage对象", description="资质材料管理表")
public class QualificationsManage extends Model<QualificationsManage> {

    private static final long serialVersionUID=1L;

    @TableId(value = "qualifications_id", type = IdType.ID_WORKER_STR)
    private String qualificationsId;

    @ApiModelProperty(value = "类型 HOME 家用  COMMERCIAL 商用")
    private String type;

    @ApiModelProperty(value = "大类id")
    private String mainId;

    @ApiModelProperty(value = "产品大类")
    private String mainName;

    @ApiModelProperty(value = "服务类型id")
    private String serviceTypeId;

    @ApiModelProperty(value = "服务类型")
    private String serviceType;

    @ApiModelProperty(value = "材料名称")
    private String materialName;

    @ApiModelProperty(value = "格式要求")
    private String formatType;

    @ApiModelProperty(value = "提示语")
    private String notes;

    @ApiModelProperty(value = "是否启用 YES是 NO否")
    private String status;

    @ApiModelProperty(value = "是否必传 YES是 NO否  工程资质是大工必传")
    private String mustPass;

    @ApiModelProperty(value = "YES 资质  NO 工程师资质")
    private String scienceType;

    @ApiModelProperty(value = "创建人（制单人）")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "小工是否必传 YES是 NO否")
    private String mustSmallPass;


    @Override
    protected Serializable pkVal() {
        return this.qualificationsId;
    }

}
