package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 短信发送记录
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="SmsRecord对象", description="短信发送记录")
public class SmsRecord extends Model<SmsRecord> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "工单号")
    private String orderBaseId;

    @ApiModelProperty(value = "工单类型(工单类型 INSTALL=安装单  REPAIR=维修单  RETURN_EXCHANGE=退换货  TRADE_IN=以旧换新MAINTENANCE=维保工单)")
    private String orderType;

    @ApiModelProperty(value = "短信类型(1:预约上门,2:预约无人接听,3:暂不安装,4:改约,5:产品送修,6:工单评价,7:回访无人接听,8:差评回访无人接听[收纳阿里短信 9:登陆 10:注册 11:修改信息 12:无人接听 13:指派师父 14:预约])")
    private Integer type;

    @ApiModelProperty(value = "用户电话")
    private String phone;

    @ApiModelProperty(value = "发送内容")
    private String content;

    @ApiModelProperty(value = "发送码  0~9999的随机数")
    private String fsma;

    @ApiModelProperty(value = "发送时间")
    private Date sendTime;

    @ApiModelProperty(value = "回复内容")
    private String replyContent;

    @ApiModelProperty(value = "回复时间")
    private Date replyTime;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
