package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="Street对象", description="")
public class Street extends Model<Street> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "街道id")
    @TableId(value = "street_id", type = IdType.ID_WORKER_STR)
    private String streetId;

    @ApiModelProperty(value = "街道")
    private String street;

    @ApiModelProperty(value = "区域id")
    private String areaId;

    @ApiModelProperty(value = "区域名")
    private String area;

    @ApiModelProperty(value = "市id")
    private String cityId;

    @ApiModelProperty(value = "市名")
    private String city;

    @ApiModelProperty(value = "省id")
    private String provinceId;

    @ApiModelProperty(value = "省名")
    private String province;

    @ApiModelProperty(value = "状态 1=有效  0=无效")
    private Boolean status;

    @ApiModelProperty(value = "区号")
    private String areaNo;

    @ApiModelProperty(value = "邮政编码")
    private String postalCode;

    @ApiModelProperty(value = "区县行政代码")
    private String dcCode;

    @ApiModelProperty(value = "旧区县行政代码")
    private String oldDcCode;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "首字母(大写)")
    @TableField("Initial")
    private String Initial;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;


    @Override
    protected Serializable pkVal() {
        return this.streetId;
    }

}
