package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 网点合同文件
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WebsitFile对象", description="网点合同文件")
public class WebsitFile extends Model<WebsitFile> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "网点id")
    private String websitId;

    @ApiModelProperty(value = "文件地址")
    private String fileUrl;

    @ApiModelProperty(value = "文件名称")
    private String fileName;

    @ApiModelProperty(value = "附件状态 YES 签署 NO待签署")
    private String status;

    @ApiModelProperty(value = "创建人（制单人）")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "MAIN 主文件  SECOND 附件合同")
    private String type;

    @ApiModelProperty(value = "HOME 家用  COMMERCIAL 商用")
    private String categoryType;

    @ApiModelProperty(value = "合同模板id")
    private String contractTemplateId;

    @ApiModelProperty(value = "法大大模板编号")
    private String fadadaTemplateId;

    @ApiModelProperty(value = "法大大合同编号")
    private String fadadaContractId;

    @ApiModelProperty(value = "签署的交易号")
    private String fadadaTransactionId;

    @ApiModelProperty(value = "法大大批量签批次号")
    private String fadadaBatchId;

    @ApiModelProperty(value = "法大大批量请求标题")
    private String fadadaBatchTitle;

    @ApiModelProperty(value = "法大大签章数据")
    private String fadadaSignData;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
