package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 网点重点信息变更
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WebsitMainInfoChange对象", description="网点重点信息变更")
public class WebsitMainInfoChange extends Model<WebsitMainInfoChange> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "网点重点信息变更id")
    @TableId(value = "websit_main_info_change_id", type = IdType.ID_WORKER_STR)
    private String websitMainInfoChangeId;

    @ApiModelProperty(value = "网点编号")
    private String websitId;

    @ApiModelProperty(value = "服务类目id")
    private String serviceCategoryId;

    @ApiModelProperty(value = "服务类目")
    private String serviceCategoryName;

    @ApiModelProperty(value = "变更内容")
    private String changeContent;

    @ApiModelProperty(value = "变更前网点名称")
    private String changeBeforeWebsitName;

    @ApiModelProperty(value = "变更后网点名称")
    private String changeAfterWebsitName;

    @ApiModelProperty(value = "是否变更网点名称 YES=是 NO=否")
    private String isChangeWebsit;

    @ApiModelProperty(value = "变更前税号")
    private String changeBeforeTaxNo;

    @ApiModelProperty(value = "变更后税号")
    private String changeAfterTaxNo;

    @ApiModelProperty(value = "是否变更税号 YES=是 NO=否")
    private String isChangeTaxNo;

    @ApiModelProperty(value = "变更前法人名称")
    private String changeBeforeLegalName;

    @ApiModelProperty(value = "变更后法人名称")
    private String changeAfterLegalName;

    @ApiModelProperty(value = "变更前法人身份证号")
    private String changeBeforeLegalId;

    @ApiModelProperty(value = "变更后法人身份证号")
    private String changeAfterLegalId;

    @ApiModelProperty(value = "是否变更法人 YES=是 NO=否")
    private String isChangeLegal;

    @ApiModelProperty(value = "变更前开户银行")
    private String changeBeforeBankName;

    @ApiModelProperty(value = "变更后开户银行")
    private String changeAfterBankName;

    @ApiModelProperty(value = "变更前银行行号")
    private String changeBeforeBankRow;

    @ApiModelProperty(value = "变更后银行行号")
    private String changeAfterBankRow;

    @ApiModelProperty(value = "变更前银行账户")
    private String changeBeforeBankNo;

    @ApiModelProperty(value = "变更后银行账户")
    private String changeAfterBankNo;

    @ApiModelProperty(value = "是否变银行信息 YES=是 NO=否")
    private String isChangeBank;

    @ApiModelProperty(value = "变更前是否承揽电商工单 YES=是 NO=否")
    private String changeBeforeOnlineWork;

    @ApiModelProperty(value = "变更后是否承揽电商工单 YES=是 NO=否")
    private String changeAfterOnlineWork;

    @ApiModelProperty(value = "是否变其他信息 YES=是 NO=否")
    private String isChangeOther;

    @ApiModelProperty(value = "服务商审核结果 OK=通过 FAIL=不通过")
    private String serviceExamine;

    @ApiModelProperty(value = "服务商审核意见")
    private String serviceExamineRemark;

    @ApiModelProperty(value = "平台审核结果 OK=通过 FAIL=不通过")
    private String platformExamine;

    @ApiModelProperty(value = "平台审核意见")
    private String platformExamineRemark;

    @ApiModelProperty(value = "状态 ON=有效 OFF=无效")
    private String status;

    @ApiModelProperty(value = "单据状态 SAVE=保存 WAIT=待审核 OK=审核通过 REVIEWED=已复核 FAIL=审核失败")
    private String examineStatus;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "提交人")
    private String submitBy;

    @ApiModelProperty(value = "提交时间")
    private Date submitTime;

    @ApiModelProperty(value = "审核人")
    private String examineBy;

    @ApiModelProperty(value = "审核时间")
    private Date examineTime;

    @ApiModelProperty(value = "复核人")
    private String reviewBy;

    @ApiModelProperty(value = "复核时间")
    private Date reviewTime;


    @Override
    protected Serializable pkVal() {
        return this.websitMainInfoChangeId;
    }

}
