package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 品牌对应网点
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WebsitOrderSign对象", description="品牌对应网点")
public class WebsitOrderSign extends Model<WebsitOrderSign> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "集团id")
    private String groupCompanyId;

    @ApiModelProperty(value = "集团名称")
    private String groupCompanyName;

    @ApiModelProperty(value = "总包商户/商户编号(结算主体)")
    private String brandId;

    @ApiModelProperty(value = "总包商户/商户名称(结算主体)")
    private String brandName;

    @ApiModelProperty(value = "网点id")
    private String websitId;

    @ApiModelProperty(value = "商户标识")
    private String merchantSign;

    @ApiModelProperty(value = "结算主体网点系统编号")
    private String brandSysWebsitNumber;

    @ApiModelProperty(value = "结算主体网点编号")
    private String brandWebsitId;

    @ApiModelProperty(value = "结算主体网点名称")
    private String brandWebsitName;

    @ApiModelProperty(value = "上级销售网点编号")
    private String refParentSaleWebsitId;

    @ApiModelProperty(value = "上级售后网点编号")
    private String refParentAfterWebsitId;

    @ApiModelProperty(value = "创建人（制单人）")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
