package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 师傅服务类型的大类明细
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WebsitServiceCategoryDetail对象", description="师傅服务类型的大类明细")
public class WebsitServiceCategoryDetail extends Model<WebsitServiceCategoryDetail> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "集团公司id")
    private String groupCompanyId;

    @ApiModelProperty(value = "结算主题id")
    private String brandId;

    @ApiModelProperty(value = "结算主体名称")
    private String brandName;

    @ApiModelProperty(value = "网点服务资质id")
    private String websitServiceCategoryId;

    @ApiModelProperty(value = "网点编号")
    private String websitId;

    @ApiModelProperty(value = "网点类型 PROVIDER=总包服务商 NETWORK=服务商网点 X1=总包商户 X2=商户网点")
    private String websitType;

    @ApiModelProperty(value = "结算主体方网点编号")
    private String brandWebsitId;

    @ApiModelProperty(value = "服务类目id")
    private String serviceCategoryId;

    @ApiModelProperty(value = "服务类目名称")
    private String serviceCategoryName;

    @ApiModelProperty(value = "类型：HOME=家用，COMMERCIAL=商用")
    private String flag;

    @ApiModelProperty(value = "工单类型 参考字典 ORDER_TYPE")
    private String type;

    @ApiModelProperty(value = "工单类型名称")
    private String typeName;

    @ApiModelProperty(value = "服务类型id")
    private String mainId;

    @ApiModelProperty(value = "服务大类名称")
    private String mainName;

    @ApiModelProperty(value = "是否已配置渠道和区域的派单规则(YES/NO)")
    private String isChannelArea;

    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "总包商户id(作废)")
    private String customerWebsitId;

    @ApiModelProperty(value = "总包商户名称（作废）")
    private String customerWebsitName;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
