package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 师傅品牌帐号
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WorkerBrandAccount对象", description="师傅品牌帐号")
public class WorkerBrandAccount extends Model<WorkerBrandAccount> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "师傅id")
    private String workerId;

    @ApiModelProperty(value = "网点师傅id")
    private String websitWorkerId;

    @ApiModelProperty(value = "集团id")
    private String groupCompanyId;

    @ApiModelProperty(value = "集团名称")
    private String groupCompanyName;

    @ApiModelProperty(value = "网点id")
    private String websitId;

    @ApiModelProperty(value = "网点名称")
    private String websitName;

    @ApiModelProperty(value = "结算主体网点编号")
    private String brandWebsitId;

    @ApiModelProperty(value = "结算主体网点名称")
    private String brandWebsitName;

    @ApiModelProperty(value = "结算主体的师傅id主键")
    private String brandWorkerId;

    @ApiModelProperty(value = "结算主体师傅编号")
    private String brandWorkerNumber;

    @ApiModelProperty(value = "结算主体的师傅帐号状态 ON=正常  OFF=禁用")
    private String brandWorkerStatus;

    @ApiModelProperty(value = "有效日期")
    private Date expireTime;

    @ApiModelProperty(value = "复核日期")
    private Date reviewTime;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "修改时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "修改人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "是否已删除  1=已删 0=未删")
    @TableLogic
    private Boolean del;

    @ApiModelProperty(value = "同步时间-对外")
    private Date outSyncTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
