package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 积分等级变动记录
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WorkerGradeRecord对象", description="积分等级变动记录")
public class WorkerGradeRecord extends Model<WorkerGradeRecord> {

    private static final long serialVersionUID=1L;

    @TableId(value = "grade_change_id", type = IdType.ID_WORKER_STR)
    private String gradeChangeId;

    @ApiModelProperty(value = "工程师id")
    private String workerId;

    @ApiModelProperty(value = "师傅名称")
    private String workerName;

    @ApiModelProperty(value = "移动电话")
    private String mobile;

    @ApiModelProperty(value = "身份证")
    private String idcard;

    @ApiModelProperty(value = "变更前等级")
    private String gradeChangeBefore;

    @ApiModelProperty(value = "变更后等级")
    private String gradeChangeAfter;

    @ApiModelProperty(value = "创建人（制单人）")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "变更后等级id")
    private String gradeConfigureId;

    @ApiModelProperty(value = "变更前等级id")
    private String gradeConfigureBeforeId;


    @Override
    protected Serializable pkVal() {
        return this.gradeChangeId;
    }

}
