package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 技能等级配置
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WorkerSkillLevelConfig对象", description="技能等级配置")
public class WorkerSkillLevelConfig extends Model<WorkerSkillLevelConfig> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "技能等级配置id")
    @TableId(value = "worker_skill_level_config_id", type = IdType.ID_WORKER_STR)
    private String workerSkillLevelConfigId;

    @ApiModelProperty(value = "类型 INSTALL=安装  REPAIR=维修")
    private String type;

    @ApiModelProperty(value = "技能等级id")
    private String workerSkillLevelId;

    @ApiModelProperty(value = "技能等级名称")
    private String workerSkillLevelName;

    @ApiModelProperty(value = "品类")
    private String categoryCode;

    @ApiModelProperty(value = "技能认证加分")
    private Integer skillAuthAdd;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @ApiModelProperty(value = "true:已删除，false:未删除")
    @TableLogic
    private Boolean del;


    @Override
    protected Serializable pkVal() {
        return this.workerSkillLevelConfigId;
    }

}
