package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 技能等级配置明细
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WorkerSkillLevelConfigItem对象", description="技能等级配置明细")
public class WorkerSkillLevelConfigItem extends Model<WorkerSkillLevelConfigItem> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "技能等级配件明细id")
    @TableId(value = "worker_skill_level_config_item_id", type = IdType.ID_WORKER_STR)
    private String workerSkillLevelConfigItemId;

    @ApiModelProperty(value = "技能等级配置id")
    private String workerSkillLevelConfigId;

    @ApiModelProperty(value = "明细类型 C=品类 L=标签")
    private String itemType;

    @ApiModelProperty(value = "编号")
    private String itemCode;

    @ApiModelProperty(value = "名称")
    private String itemValue;

    @ApiModelProperty(value = "结算完工量")
    private Integer settlementCount;


    @Override
    protected Serializable pkVal() {
        return this.workerSkillLevelConfigItemId;
    }

}
