package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 师傅服务区域(作废)
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WorkerStreet对象", description="师傅服务区域(作废)")
public class WorkerStreet extends Model<WorkerStreet> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "师傅id/师傅编号")
    private String workerId;

    @ApiModelProperty(value = "网点id")
    private String websitId;

    @ApiModelProperty(value = "网点师傅id")
    private String websitWorkerId;

    @ApiModelProperty(value = "A=核心区域 B=重点区域 C=其余区域")
    private String type;

    @ApiModelProperty(value = "省id")
    private String provinceId;

    @ApiModelProperty(value = "省")
    private String province;

    @ApiModelProperty(value = "市id")
    private String cityId;

    @ApiModelProperty(value = "市")
    private String city;

    @ApiModelProperty(value = "区id")
    private String areaId;

    @ApiModelProperty(value = "区")
    private String area;

    @ApiModelProperty(value = "街道id")
    private String streetId;

    @ApiModelProperty(value = "街道")
    private String street;

    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
