package com.zfire.jiasm.syncdata.plus.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 师傅服务区域申请变更表(作废)
 * </p>
 *
 * @author gejiang
 * @since 2023-08-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="WorkerStreetApply对象", description="师傅服务区域申请变更表(作废)")
public class WorkerStreetApply extends Model<WorkerStreetApply> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "师傅申请变更id")
    private String workerApplyId;

    @ApiModelProperty(value = "师傅id/师傅编号")
    private String workerId;

    @ApiModelProperty(value = "A=核心区域 B=重点区域")
    private String type;

    @ApiModelProperty(value = "省id")
    private String provinceId;

    @ApiModelProperty(value = "省")
    private String province;

    @ApiModelProperty(value = "市id")
    private String cityId;

    @ApiModelProperty(value = "市")
    private String city;

    @ApiModelProperty(value = "区id")
    private String areaId;

    @ApiModelProperty(value = "区")
    private String area;

    @ApiModelProperty(value = "街道id")
    private String streetId;

    @ApiModelProperty(value = "街道")
    private String street;

    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateTime;

    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    @ApiModelProperty(value = "审批状态 WAIT=待审批  OK=通过 FAIL=不通过")
    private String examineStatus;

    @ApiModelProperty(value = "审批时间")
    private Date examineTime;

    @ApiModelProperty(value = "审批备注")
    private String examineRemark;

    @ApiModelProperty(value = "审批人")
    private String examineBy;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
